## wireguard 0.0.20181218

=== src/tests/qemu/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Copyright (C) 2015-2018 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.

PWD := $(shell pwd)

CHOST := $(shell gcc -dumpmachine)
ifneq (,$(ARCH))
CBUILD := $(subst -gcc,,$(lastword $(subst /, ,$(firstword $(filter-out android,$(wildcard /usr/bin/$(ARCH)-*-gcc))))))
endif
ifeq (,$(CBUILD))
CBUILD := $(CHOST)
endif
ARCH := $(firstword $(subst -, ,$(CBUILD)))

# Set these from the environment to override
KERNEL_VERSION ?= 4.19
KERNEL_VERSION := $(KERNEL_VERSION)$(if $(DEBUG_KERNEL),$(if $(findstring -debug,$(KERNEL_VERSION)),,-debug),)
BUILD_PATH ?= $(PWD)/../../../qemu-build/$(ARCH)
DISTFILES_PATH ?= $(PWD)/distfiles
NR_CPUS ?= 4

MIRROR := https://download.wireguard.com/qemu-test/distfiles/

rwildcard=$(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2) $(filter $(subst *,%,$2),$d))
WIREGUARD_SOURCES := ../../Kbuild ../../Kconfig $(filter-out ../../tools/% ../../tests/%,$(call rwildcard,../../,*.c *.h *.S *.pl *.include))
TOOLS_SOURCES := $(wildcard ../../tools/*.c ../../tools/*.h ../../uapi/*.h ../../crypto/zinc/curve25519/curve25519-hacl64.c ../../crypto/zinc/curve25519/curve25519-fiat32.c)

default: qemu

# variable name, tarball project name, version, tarball extension, default URI base
define tar_download =
$(1)_VERSION := $(3)
$(1)_NAME := $(2)-$$($(1)_VERSION)
$(1)_TAR := $(DISTFILES_PATH)/$$($(1)_NAME:-debug=)$(4)
$(1)_PATH := $(BUILD_PATH)/$$($(1)_NAME)
$(call file_download,$$($(1)_NAME:-debug=)$(4),$(5))
endef

define file_download =
$(DISTFILES_PATH)/$(1):
	mkdir -p $(DISTFILES_PATH)
	flock -x $$@.lock -c '[ -f $$@ ] && exit 0; wget -O $$@ $(MIRROR)$(1) || wget -t inf --retry-on-http-error=404 -O $$@ $(2)$(1) || rm -f $$@'
endef

ifeq ($(findstring -rc,$(KERNEL_VERSION)),)
KERNEL_URL_DIRECTORY := https://cdn.kernel.org/pub/linux/kernel/v$(firstword $(subst ., ,$(KERNEL_VERSION:-debug=))).x/
else
KERNEL_URL_DIRECTORY := https://git.kernel.org/torvalds/t/
endif

$(eval $(call tar_download,KERNEL,linux,$(KERNEL_VERSION),.tar.gz,$(KERNEL_URL_DIRECTORY)))
$(eval $(call tar_download,MUSL,musl,1.1.20,.tar.gz,https://www.musl-libc.org/releases/))
$(eval $(call tar_download,LIBMNL,libmnl,1.0.4,.tar.bz2,https://www.netfilter.org/projects/libmnl/files/))
$(eval $(call tar_download,IPERF,iperf,3.1.7,.tar.gz,http://downloads.es.net/pub/iperf/))
$(eval $(call tar_download,BASH,bash,4.4.18,.tar.gz,https://ftp.gnu.org/gnu/bash/))
$(eval $(call tar_download,IPROUTE2,iproute2,4.13.0,.tar.gz,https://www.kernel.org/pub/linux/utils/net/iproute2/))
$(eval $(call tar_download,IPTABLES,iptables,1.6.1,.tar.bz2,https://www.netfilter.org/projects/iptables/files/))
$(eval $(call tar_download,NMAP,nmap,7.60,.tar.bz2,https://nmap.org/dist/))
$(eval $(call tar_download,IPUTILS,iputils,s20161105,.tar.gz,https://github.com/iputils/iputils/archive/s20161105.tar.gz/#))

export CFLAGS ?= -O3 -pipe
export LDFLAGS ?=
export CPPFLAGS := -I$(BUILD_PATH)/include

ifeq ($(CHOST),$(CBUILD))
CROSS_COMPILE_FLAG := --host=$(CHOST)
NOPIE_GCC := gcc -fno-PIE
CFLAGS += -march=native
OMIT_AVX512 := $(shell gcc -march=native -Q --help=target | sed -n 's/.*\-m\(avx512[^ ]*\).*\[enabled\].*/-mno-\1/p')
CFLAGS += $(OMIT_AVX512)
STRIP := strip
else
$(info Cross compilation: building for $(CBUILD) using $(CHOST))
CROSS_COMPILE_FLAG := --build=$(CBUILD) --host=$(CHOST)
export CROSS_COMPILE=$(CBUILD)-
NOPIE_GCC := $(CBUILD)-gcc -fno-PIE
STRIP := $(CBUILD)-strip
endif
ifeq ($(ARCH),aarch64)
QEMU_ARCH := aarch64
KERNEL_ARCH := arm64
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/arm64/boot/Image
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine virt,gic_version=host,accel=kvm
else
QEMU_MACHINE := -cpu cortex-a53 -machine virt
CFLAGS += -march=armv8-a -mtune=cortex-a53
endif
else ifeq ($(ARCH),aarch64_be)
QEMU_ARCH := aarch64
KERNEL_ARCH := arm64
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/arm64/boot/Image
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine virt,gic_version=host,accel=kvm
else
QEMU_MACHINE := -cpu cortex-a53 -machine virt
CFLAGS += -march=armv8-a -mtune=cortex-a53
endif
else ifeq ($(ARCH),arm)
QEMU_ARCH := arm
KERNEL_ARCH := arm
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/arm/boot/zImage
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine virt,gic_version=host,accel=kvm
else
QEMU_MACHINE := -cpu cortex-a15 -machine virt
CFLAGS += -march=armv7-a -mtune=cortex-a15 -mabi=aapcs-linux
endif
else ifeq ($(ARCH),armeb)
QEMU_ARCH := arm
KERNEL_ARCH := arm
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/arm/boot/zImage
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine virt,gic_version=host,accel=kvm
else
QEMU_MACHINE := -cpu cortex-a15 -machine virt
CFLAGS += -march=armv7-a -mabi=aapcs-linux # We don't pass -mtune=cortex-a15 due to a compiler bug on big endian.
LDFLAGS += -Wl,--be8
endif
else ifeq ($(ARCH),x86_64)
QEMU_ARCH := x86_64
KERNEL_ARCH := x86_64
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/x86/boot/bzImage
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine q35,accel=kvm
else
QEMU_MACHINE := -cpu Skylake-Server -machine q35
CFLAGS += -march=skylake-avx512
endif
else ifeq ($(ARCH),i686)
QEMU_ARCH := i386
KERNEL_ARCH := x86
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/x86/boot/bzImage
ifeq ($(subst i686,x86_64,$(CBUILD)),$(CHOST))
QEMU_MACHINE := -cpu host -machine q35,accel=kvm
else
QEMU_MACHINE := -cpu coreduo -machine q35
CFLAGS += -march=prescott
endif
else ifeq ($(ARCH),mips64)
QEMU_ARCH := mips64
KERNEL_ARCH := mips
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine malta,accel=kvm
CFLAGS += -EB
else
QEMU_MACHINE := -cpu MIPS64R2-generic -machine malta -smp 1
CFLAGS += -march=mips64r2 -EB
endif
else ifeq ($(ARCH),mips64el)
QEMU_ARCH := mips64el
KERNEL_ARCH := mips
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine malta,accel=kvm
CFLAGS += -EL
else
QEMU_MACHINE := -cpu MIPS64R2-generic -machine malta -smp 1
CFLAGS += -march=mips64r2 -EL
endif
else ifeq ($(ARCH),mips)
QEMU_ARCH := mips
KERNEL_ARCH := mips
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine malta,accel=kvm
CFLAGS += -EB
else
QEMU_MACHINE := -cpu 24Kf -machine malta -smp 1
CFLAGS += -march=mips32r2 -EB
endif
else ifeq ($(ARCH),mipsel)
QEMU_ARCH := mipsel
KERNEL_ARCH := mips
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host -machine malta,accel=kvm
CFLAGS += -EL
else
QEMU_MACHINE := -cpu 24Kf -machine malta -smp 1
CFLAGS += -march=mips32r2 -EL
endif
else ifeq ($(ARCH),powerpc64le)
QEMU_ARCH := ppc64
KERNEL_ARCH := powerpc
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host,accel=kvm -machine pseries
else
QEMU_MACHINE := -machine pseries
endif
CFLAGS += -mcpu=powerpc64le -mlong-double-64
else ifeq ($(ARCH),powerpc)
QEMU_ARCH := ppc
KERNEL_ARCH := powerpc
KERNEL_BZIMAGE := $(KERNEL_PATH)/arch/powerpc/boot/uImage
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host,accel=kvm -machine ppce500
else
QEMU_MACHINE := -machine ppce500
endif
CFLAGS += -mcpu=powerpc -mlong-double-64 -msecure-plt
else ifeq ($(ARCH),m68k)
QEMU_ARCH := m68k
KERNEL_ARCH := m68k
KERNEL_BZIMAGE := $(KERNEL_PATH)/vmlinux
ifeq ($(CHOST),$(CBUILD))
QEMU_MACHINE := -cpu host,accel=kvm -machine q800
else
QEMU_MACHINE := -machine q800
endif
else
$(error I only build: x86_64, i686, arm, armeb, aarch64, aarch64_be, mips, mipsel, mips64, mips64el, powerpc64le, powerpc, m68k)
endif

REAL_CC := $(CBUILD)-gcc
MUSL_CC := $(BUILD_PATH)/musl-gcc
export CC := $(MUSL_CC)
USERSPACE_DEPS := $(MUSL_CC) $(BUILD_PATH)/include/.installed $(BUILD_PATH)/include/linux/.installed

build: $(KERNEL_BZIMAGE)
qemu: $(KERNEL_BZIMAGE)
	rm -f $(BUILD_PATH)/result
	timeout --foreground 20m qemu-system-$(QEMU_ARCH) \
		-nodefaults \
		-nographic \
		-smp $(NR_CPUS) \
		$(QEMU_MACHINE) \
		-m $$(grep -q CONFIG_DEBUG_KMEMLEAK=y $(KERNEL_PATH)/.config && echo 1G || echo 256M) \
		-serial stdio \
		-serial file:$(BUILD_PATH)/result \
		-no-reboot \
		-monitor none \
		-kernel $<
	grep -Fq success $(BUILD_PATH)/result

$(BUILD_PATH)/init-cpio-spec.txt:
	mkdir -p $(BUILD_PATH)
	echo "file /init $(BUILD_PATH)/init 755 0 0" > $@
	echo "file /init.sh $(PWD)/../netns.sh 755 0 0" >> $@
	echo "dir /dev 755 0 0" >> $@
	echo "nod /dev/console 644 0 0 c 5 1" >> $@
	echo "dir /bin 755 0 0" >> $@
	echo "file /bin/iperf3 $(IPERF_PATH)/src/iperf3 755 0 0" >> $@
	echo "file /bin/wg $(BUILD_PATH)/tools/wg 755 0 0" >> $@
	echo "file /bin/bash $(BASH_PATH)/bash 755 0 0" >> $@
	echo "file /bin/ip $(IPROUTE2_PATH)/ip/ip 755 0 0" >> $@
	echo "file /bin/ss $(IPROUTE2_PATH)/misc/ss 755 0 0" >> $@
	echo "file /bin/ping $(IPUTILS_PATH)/ping 755 0 0" >> $@
	echo "file /bin/ncat $(NMAP_PATH)/ncat/ncat 755 0 0" >> $@
	echo "file /bin/xtables-multi $(IPTABLES_PATH)/iptables/xtables-multi 755 0 0" >> $@
	echo "slink /bin/iptables xtables-multi 777 0 0" >> $@
	echo "slink /bin/ping6 ping 777 0 0" >> $@
	echo "dir /lib 755 0 0" >> $@
	echo "file /lib/libc.so $(MUSL_PATH)/lib/libc.so 755 0 0" >> $@
	echo "slink /lib/ld-linux.so.1 libc.so 777 0 0" >> $@

ifeq ($(findstring -git,$(KERNEL_VERSION)),)
$(KERNEL_PATH)/.installed: $(KERNEL_TAR)
	mkdir -p $(KERNEL_PATH)
	flock -s $<.lock tar --strip-components=1 -C $(KERNEL_PATH) -xf $<
	sed -i "/^if INET\$$/a source \"net/wireguard/Kconfig\"" $(KERNEL_PATH)/net/Kconfig
	sed -i "/^obj-\$$(CONFIG_NETFILTER).*+=/a obj-\$$(CONFIG_WIREGUARD) += wireguard/" $(KERNEL_PATH)/net/Makefile
	ln -sfT $(shell readlink -f ../..) $(KERNEL_PATH)/net/wireguard
	touch $@
else
$(KERNEL_PATH)/.installed:
	mkdir -p $(dir $(KERNEL_PATH))
	flock -s $(dir $(KERNEL_TAR))/$(KERNEL_VERSION).lock git clone $(GIT_URI_$(patsubst %-git,%,$(patsubst %-debug,%,$(KERNEL_VERSION)))) $(KERNEL_PATH)
	touch $@
always-pull: $(KERNEL_PATH)/.installed
	flock -s $(dir $(KERNEL_TAR))/$(KERNEL_VERSION).lock git -C $(KERNEL_PATH) fetch
	flock -s $(dir $(KERNEL_TAR))/$(KERNEL_VERSION).lock git -C $(KERNEL_PATH) reset --hard FETCH_HEAD
.PHONY: always-pull
$(KERNEL_BZIMAGE): always-pull
endif

$(KERNEL_PATH)/.config: kernel.config arch/$(ARCH).config | $(KERNEL_PATH)/.installed
	cp kernel.config $(KERNEL_PATH)/minimal.config
	printf 'CONFIG_NR_CPUS=$(NR_CPUS)\nCONFIG_INITRAMFS_SOURCE="$(BUILD_PATH)/init-cpio-spec.txt"\n' >> $(KERNEL_PATH)/minimal.config
	cat arch/$(ARCH).config >> $(KERNEL_PATH)/minimal.config
	$(MAKE) -C $(KERNEL_PATH) ARCH=$(KERNEL_ARCH) allnoconfig
	cd $(KERNEL_PATH) && ARCH=$(KERNEL_ARCH) scripts/kconfig/merge_config.sh -n .config minimal.config
	$(if $(findstring -debug,$(KERNEL_VERSION)),cd $(KERNEL_PATH) && sed -i 's/^EXTRAVERSION =.*/EXTRAVERSION = -debug/' Makefile && ARCH=$(KERNEL_ARCH) scripts/kconfig/merge_config.sh -n .config $(PWD)/debug.config,)

$(KERNEL_BZIMAGE): $(KERNEL_PATH)/.config $(BUILD_PATH)/init-cpio-spec.txt $(MUSL_PATH)/lib/libc.so $(IPERF_PATH)/src/iperf3 $(BUILD_PATH)/tools/wg $(IPUTILS_PATH)/ping $(BASH_PATH)/bash $(IPROUTE2_PATH)/misc/ss $(IPROUTE2_PATH)/ip/ip $(IPTABLES_PATH)/iptables/xtables-multi $(NMAP_PATH)/ncat/ncat $(BUILD_PATH)/init ../netns.sh $(WIREGUARD_SOURCES) $(TOOLS_SOURCES)
	LOCALVERSION="" $(MAKE) -C $(KERNEL_PATH) ARCH=$(KERNEL_ARCH) CROSS_COMPILE=$(CROSS_COMPILE) CC="$(NOPIE_GCC)"

$(BUILD_PATH)/include/linux/.installed: | $(KERNEL_PATH)/.config
	LOCALVERSION="" $(MAKE) -C $(KERNEL_PATH) INSTALL_HDR_PATH=$(BUILD_PATH) ARCH=$(KERNEL_ARCH) CROSS_COMPILE=$(CROSS_COMPILE) headers_install
	touch $@

$(MUSL_PATH)/lib/libc.so: $(MUSL_TAR)
	mkdir -p $(BUILD_PATH)
	flock -s $<.lock tar -C $(BUILD_PATH) -xf $<
	cd $(MUSL_PATH) && CC=$(REAL_CC) ./configure --prefix=/ --disable-static --build=$(CBUILD)
	$(MAKE) -C $(MUSL_PATH)
	$(STRIP) -s $@

$(BUILD_PATH)/include/.installed: $(MUSL_PATH)/lib/libc.so
	$(MAKE) -C $(MUSL_PATH) DESTDIR=$(BUILD_PATH) install-headers
	touch $@

$(MUSL_CC): $(MUSL_PATH)/lib/libc.so

## wireguard 0.0.20170214

=== debian/changelog ===
wireguard (0.0.20170214-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 14 Feb 2017 08:51:02 -0500

wireguard (0.0.20170213-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 13 Feb 2017 19:06:05 -0500

wireguard (0.0.20170115-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 06 Feb 2017 04:40:14 -0500

wireguard (0.0.20170105-1) UNRELEASED; urgency=medium

  * New upstream release
    - adds wg-quick
    - adds bash tab completion for wg
    - adds systemd .service template for wg-quick

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 11 Jan 2017 23:19:09 -0500

wireguard (0.0.20161230-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 03 Jan 2017 02:21:26 -0500

wireguard (0.0.20161223-1) unstable; urgency=medium

  * New upstream release.
  * use uptream's install-dkms Makefile target and dkms.conf instead of
    maintaining our own.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 24 Dec 2016 16:58:46 -0500

wireguard (0.0.20161218-1) unstable; urgency=medium

  * New upstream release.
  * Move from experimental to unstable.  Upstream isn't committed to a
    long-term stable branch, so we should keep this from migrating to
    stretch, but it has stabilized enough for wider distribution.
  * Note: we are not using upstream's install-dkms Makefile target.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 22 Dec 2016 08:25:15 -0500

wireguard (0.0.20161129-experimental1) experimental; urgency=medium

  * new upstream release
  * generate src/version.h from debian package version instead of git
    repo.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 05 Dec 2016 23:01:22 -0500

wireguard (0.0.20161116.1-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 17 Nov 2016 08:07:52 +0900

wireguard (0.0.20161110-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 10 Nov 2016 12:25:50 -0800

wireguard (0.0.20161105-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 06 Nov 2016 01:47:35 -0400

wireguard (0.0.20161103-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 04 Nov 2016 10:34:52 -0400

wireguard (0.0.20161102-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 02 Nov 2016 12:52:58 -0400

wireguard (0.0.20161025-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 25 Oct 2016 10:05:12 -0400

wireguard (0.0.20161014-experimental1) experimental; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 24 Oct 2016 14:04:50 -0400

wireguard (0.0.20160808-experimental2) experimental; urgency=medium

  [ Jason A. Donenfeld ]
  * properly ship self-tests (Closes: #833961)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 12 Aug 2016 01:45:04 -0400

wireguard (0.0.20160808-experimental1) experimental; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 08 Aug 2016 16:54:39 -0400

wireguard (0.0.20160722-experimental1) experimental; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 22 Jul 2016 17:21:11 -0400

wireguard (0.0.20160711-experimental1) experimental; urgency=medium

  * New upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 12 Jul 2016 13:20:26 +0200

wireguard (0.0.20160708.1-experimental1) experimental; urgency=medium

  * New upstream release
  * build-depend on pkg-config
  * ship upstream examples

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 08 Jul 2016 23:13:54 +0200

wireguard (0.0.20160630-experimental2) experimental; urgency=medium

  * avoid shipping example/demo scripts at request of upstream
  * limit wireguard-tools to only linux platforms, since it makes no sense
    elsewhere.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 02 Jul 2016 10:32:49 -0400

wireguard (0.0.20160630-experimental1) experimental; urgency=medium

  * First package upload (Closes: #829107)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 30 Jun 2016 12:50:33 -0400

=== debian/control ===
Source: wireguard
Section: net
Priority: extra
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper (>= 10~),
 dkms,
 libmnl-dev,
 pkg-config
Standards-Version: 3.9.8
Homepage: https://www.wireguard.io
Vcs-Git: https://anonscm.debian.org/git/collab-maint/wireguard.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/wireguard.git

Package: wireguard-dkms
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 wireguard-tools
Description: fast, modern, secure kernel VPN tunnel (DKMS version)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package uses DKMS to automatically build the wireguard kernel
 module.

Package: wireguard-tools
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 wireguard-dkms | wireguard-modules
Description: fast, modern, secure kernel VPN tunnel (userland utilities)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package contains command-line tools to interact with the
 WireGuard kernel module.  Currently, it provides only a single tool:
 .
 wg: set and retrieve configuration of WireGuard interfaces

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WIREGUARD_ARGS = WITH_BASHCOMPLETION=yes WITH_WGQUICK=yes WITH_SYSTEMDUNITS=yes

%:
	dh $@ --with dkms

override_dh_auto_install-indep:
	$(MAKE) -C src DESTDIR=../debian/wireguard-dkms DKMSDIR=/usr/src/wireguard-$(DEB_VERSION)/ dkms-install

override_dh_auto_build-arch:
	$(MAKE) -C src/tools $(WIREGUARD_ARGS)

override_dh_auto_install-arch:
	$(MAKE) -C src/tools DESTDIR=../../debian/wireguard-tools $(WIREGUARD_ARGS) install

override_dh_dkms:
	dh_dkms -p wireguard-dkms -- src/dkms.conf

=== debian/watch ===
version=4
 https://git.zx2c4.com/WireGuard \
 /WireGuard/snapshot/WireGuard-@ANY_VERSION@@ARCHIVE_EXT@

## wireguard 0.0.20170214-1ubuntu0.17.04.1

=== debian/changelog ===
wireguard (0.0.20170214-1ubuntu0.17.04.1) zesty; urgency=medium

  * WireGuard is not yet released software and was supposed to stay in Debian
    sid and certainly not migrate to Ubuntu stable. Since pre-releases do not
    belong in a non-rolling distribution like Ubuntu, this update is an empty
    package placeholder. As soon as WireGuard upstream releases their first
    real release, this package will be updated again. Until then, you're best
    using ppa:wireguard/wireguard or following the directions on
    <https://www.wireguard.io/install>.  (LP: #1685522)

 -- Jason A. Donenfeld <Jason@zx2c4.com>  Mon, 24 Apr 2017 00:39:58 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,12 @@
 Source: wireguard
 Section: net
 Priority: extra
-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Jason A. Donenfeld <Jason@zx2c4.com>
+XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
- debhelper (>= 10~),
- dkms,
- libmnl-dev,
- pkg-config
+ debhelper (>= 10~)
 Standards-Version: 3.9.8
 Homepage: https://www.wireguard.io
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/wireguard.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/wireguard.git
 
 Package: wireguard-dkms
 Architecture: all
@@ -29,12 +25,15 @@
  .
  This package uses DKMS to automatically build the wireguard kernel
  module.
+ .
+ This package is currently an empty placeholder. You may find an up
+ to date version at ppa:wireguard/wireguard or directions on packages
+ at <https://www.wireguard.io/install/>.
 
 Package: wireguard-tools
-Architecture: linux-any
+Architecture: all
 Depends:
- ${misc:Depends},
- ${shlibs:Depends}
+ ${misc:Depends}
 Recommends:
  wireguard-dkms | wireguard-modules
 Description: fast, modern, secure kernel VPN tunnel (userland utilities)
@@ -50,3 +49,7 @@
  WireGuard kernel module.  Currently, it provides only a single tool:
  .
  wg: set and retrieve configuration of WireGuard interfaces
+ .
+ This package is currently an empty placeholder. You may find an up
+ to date version at ppa:wireguard/wireguard or directions on packages
+ at <https://www.wireguard.io/install/>.

## wireguard 0.0.20181218

=== debian/changelog ===
wireguard (0.0.20181218-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 06 Jan 2019 13:51:35 -0800

wireguard (0.0.20181218-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 18 Dec 2018 13:50:07 -0500

wireguard (0.0.20181119-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 19 Nov 2018 13:30:22 -0500

wireguard (0.0.20181115-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 15 Nov 2018 17:47:30 -0500

wireguard (0.0.20181018-1) unstable; urgency=medium

  * new upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 18 Oct 2018 09:42:59 -0400

wireguard (0.0.20181007-1) unstable; urgency=medium

  * new upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 18 Oct 2018 09:42:44 -0400

wireguard (0.0.20180925-1) unstable; urgency=medium

  * new upstream snapshot release
  * d/copyright: update for licensing tweaks

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 27 Sep 2018 17:02:13 -0400

wireguard (0.0.20180918-1) unstable; urgency=medium

  * new upstream snapshot release
  * d/copyright: note zinc change to MIT license

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 19 Sep 2018 15:44:54 -0400

wireguard (0.0.20180910-1) unstable; urgency=medium

  * new upstream snapshot release
  * d/copyright update for new code sources

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 12 Sep 2018 00:28:31 -0400

wireguard (0.0.20180904-2) unstable; urgency=medium

  * dkms: use upstream version instead of debian version (closes: #906019)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 06 Sep 2018 13:08:44 -0400

wireguard (0.0.20180904-1) unstable; urgency=medium

  * New upstream snapshot release
  * Standards-Version: bump to 4.2.1 (no changes needed)
  * debian/copyright: update move of sources to zinc

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Sep 2018 16:24:17 -0400

wireguard (0.0.20180809-1) unstable; urgency=medium

  * Standards-Version: bump to 4.2.0 (no changes needed)
  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Sep 2018 16:24:06 -0400

wireguard (0.0.20180802-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 03 Aug 2018 09:31:12 -0400

wireguard (0.0.20180731-2) unstable; urgency=medium

  * ship /etc/wireguard mode 0700 by default (closes: #902831)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 31 Jul 2018 18:00:49 -0400

wireguard (0.0.20180731-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 31 Jul 2018 15:42:42 -0400

wireguard (0.0.20180718-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 31 Jul 2018 15:42:30 -0400

wireguard (0.0.20180708-1) unstable; urgency=medium

  * New upstream snapshot release
  * Standards-Version: bumped to 4.1.5 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 09 Jul 2018 15:03:15 -0400

wireguard (0.0.20180625-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 25 Jun 2018 14:02:58 -0400

wireguard (0.0.20180620-1) unstable; urgency=medium

  * new upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 21 Jun 2018 10:25:55 -0400

wireguard (0.0.20180613-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS (Closes: #900891) Thanks, Helmut Grohne!

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 18 Jun 2018 14:35:37 -0400

wireguard (0.0.20180613-2) unstable; urgency=medium

  * avoid requiring glibc-2.25 for wireguard-tools (Closes: #901802)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 18 Jun 2018 14:18:31 -0400

wireguard (0.0.20180613-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 14 Jun 2018 09:59:56 -0400

wireguard (0.0.20180531-1) unstable; urgency=medium

  * New upstream snapshot release
  * update debian/copyright

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 01 Jun 2018 16:08:33 -0400

wireguard (0.0.20180524-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 24 May 2018 10:38:53 -0400

wireguard (0.0.20180519-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 21 May 2018 13:42:17 -0400

wireguard (0.0.20180513-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 14 May 2018 17:28:50 -0400

wireguard (0.0.20180420-1) unstable; urgency=medium

  * New upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 14 May 2018 17:28:31 -0400

wireguard (0.0.20180413-1) unstable; urgency=medium

  * New upstream snapshot release
  * Standards-Version: bump to 4.1.4 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 20 Apr 2018 12:43:32 -0700

wireguard (0.0.20180304-1) unstable; urgency=medium

  * new upstream snapshot release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 16 Mar 2018 01:31:06 +0000

wireguard (0.0.20180218-1) unstable; urgency=medium

  * new upstream snapshot release
  * update Jason's signing key
  * d/control: set Rules-Requires-Root: no
  * convert packaging VCS branchnames to DEP-14
  * d/copyright: embeddable-wg-library is LGPL-2.1+

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 20 Feb 2018 14:51:20 -0800

wireguard (0.0.20180202-1) unstable; urgency=medium

  * new upstream snapshot release
  * loosen versioned dependencies of wireguard metapackage


=== debian/control ===
Source: wireguard
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper (>= 11~),
 dkms,
 libmnl-dev,
 pkg-config,
 systemd,
Standards-Version: 4.2.1
Homepage: https://www.wireguard.com
Vcs-Git: https://salsa.debian.org/debian/wireguard.git
Vcs-Browser: https://salsa.debian.org/debian/wireguard
Rules-Requires-Root: no

Package: wireguard
Architecture: all
Depends:
 wireguard-dkms (= ${source:Version}) | wireguard-modules (>= 0.0.20171001),
 wireguard-tools (>= 0.0.20171001),
 ${misc:Depends},
Description: fast, modern, secure kernel VPN tunnel (metapackage)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This metapackage explicitly depends on both the kernel module and the
 userspace tooling.

Package: wireguard-dkms
Architecture: all
Section: kernel
Depends:
 ${misc:Depends},
Recommends:
 wireguard-tools (= ${source:Version}),
Description: fast, modern, secure kernel VPN tunnel (DKMS version)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package uses DKMS to automatically build the wireguard kernel
 module.

Package: wireguard-tools
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 wireguard-dkms (= ${source:Version}) | wireguard-modules (>= 0.0.20171001),
Description: fast, modern, secure kernel VPN tunnel (userland utilities)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package contains command-line tools to interact with the
 WireGuard kernel module.  Currently, it provides only a single tool:
 .
 wg: set and retrieve configuration of WireGuard interfaces

## wireguard 0.0.20190702

=== debian/changelog ===
wireguard (0.0.20190702-1) unstable; urgency=medium

  * new upstream version

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 02 Jul 2019 09:02:32 -0400

wireguard (0.0.20190601-1) unstable; urgency=medium

  * new upstream version

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 17 Jun 2019 12:25:58 -0400

wireguard (0.0.20190406-1) unstable; urgency=medium

  * New upstream version
  * refresh patches

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 08 Apr 2019 17:09:41 -0400

wireguard (0.0.20190227-1) unstable; urgency=medium

  * New upstream version

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 01 Mar 2019 13:34:53 -0500

wireguard (0.0.20190123-1) unstable; urgency=medium

  [ Fabian Grünbichler ]
  * wireguard.postinst: Add module reload on upgrade (Closes: #913446)

  [ Daniel Kahn Gillmor ]
  * New upstream version (Closes: #919232)
  * Tighten dependencies and description of wireguard metapackage
  * Fine-tune module reload code on wireguard.postinst
  * Standards-Version: bump to 4.3.0 (no changes needed)
  * Update debian/copyright
  * override lintian warning version-substvar-for-external-package
  * move to debhelper-compat 12

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 28 Jan 2019 14:31:53 -0500

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: wireguard
 Section: net
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  dkms,
  libmnl-dev,
  pkg-config,
  systemd,
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://www.wireguard.com
 Vcs-Git: https://salsa.debian.org/debian/wireguard.git
 Vcs-Browser: https://salsa.debian.org/debian/wireguard
@@ -18,8 +17,8 @@
 Package: wireguard
 Architecture: all
 Depends:
- wireguard-dkms (= ${source:Version}) | wireguard-modules (>= 0.0.20171001),
- wireguard-tools (>= 0.0.20171001),
+ wireguard-dkms (= ${source:Version}) | wireguard-modules (= ${source:Version}),
+ wireguard-tools (>= ${source:Version}),
  ${misc:Depends},
 Description: fast, modern, secure kernel VPN tunnel (metapackage)
  WireGuard is a novel VPN that runs inside the Linux Kernel and uses
@@ -31,7 +30,8 @@
  many different circumstances. It runs over UDP.
  .
  This metapackage explicitly depends on both the kernel module and the
- userspace tooling.
+ userspace tooling, and tries to load the new kernel module upon
+ installation, if wireguard is already in use on the system.
 
 Package: wireguard-dkms
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_VERSION_UPSTREAM

WIREGUARD_ARGS = WITH_BASHCOMPLETION=yes WITH_WGQUICK=yes WITH_SYSTEMDUNITS=yes

%:
	dh $@ --with dkms

override_dh_auto_install-indep:
	$(MAKE) -C src DESTDIR=../debian/wireguard-dkms DKMSDIR=/usr/src/wireguard-$(DEB_VERSION_UPSTREAM) dkms-install

override_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=src/tools -- $(WIREGUARD_ARGS)

override_dh_auto_install-arch:
	$(MAKE) -C src/tools DESTDIR=../../debian/wireguard-tools $(WIREGUARD_ARGS) install

override_dh_dkms:
	dh_dkms -p wireguard-dkms -- src/dkms.conf

override_dh_installchangelogs:
	dh_installchangelogs debian/upstream.changelog

override_dh_fixperms:
	dh_fixperms -Xetc/wireguard

## wireguard 0.0.20190913

=== debian/changelog ===
wireguard (0.0.20190913-1ubuntu1) eoan; urgency=low

  * drop ADT test which requires full internet access and also abuses a
    test server without permission.
  * drop inappropriate patches:
    - d/p/0002-Avoid-requiring-glibc-2.25-for-wireguard-tools.patch:
      we have a high enough version of glibc in all pockets to allow
      enabling this.  Disabling this reduces entropy.
    - d/p/0003-compat-fix-on-debian-4.9.168-in-sloppy-manner.patch:
      we do not ship this stable kernel stream.

 -- Andy Whitcroft <apw@ubuntu.com>  Fri, 27 Sep 2019 16:54:55 +0100

wireguard (0.0.20190913-1) unstable; urgency=medium

  * new upstream release
  * verbose build to satisfy compiler-flags-hidden complaint from bls

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 26 Sep 2019 10:29:32 +0200

wireguard (0.0.20190905-1) unstable; urgency=medium

  * new upstream release
  * refresh patches
  * include ${perl:Depends} in wireguard-dkms

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 08 Sep 2019 15:42:09 -0400

wireguard (0.0.20190702-3) unstable; urgency=medium

  * clean up wireguard-modules versioned dependency (Closes: #930432)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 19 Aug 2019 20:52:22 -0400

wireguard (0.0.20190702-2) unstable; urgency=medium

  * Work around faulty siphash backport (Closes: #934763)
  * standards-version: bump to 4.4.0 (no changes needed)
  * override package-supports-alternative-init-but-no-init.d-script for
    wireguard-tools

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 19 Aug 2019 18:07:59 -0400

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libmnl-dev,
  pkg-config,
  systemd,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://www.wireguard.com
 Vcs-Git: https://salsa.debian.org/debian/wireguard.git
 Vcs-Browser: https://salsa.debian.org/debian/wireguard
@@ -17,7 +17,7 @@
 Package: wireguard
 Architecture: all
 Depends:
- wireguard-dkms (= ${source:Version}) | wireguard-modules (= ${source:Version}),
+ wireguard-dkms (= ${source:Version}) | wireguard-modules (= ${source:Upstream-Version}),
  wireguard-tools (>= ${source:Version}),
  ${misc:Depends},
 Description: fast, modern, secure kernel VPN tunnel (metapackage)
@@ -38,6 +38,7 @@
 Section: kernel
 Depends:
  ${misc:Depends},
+ ${perl:Depends},
 Recommends:
  wireguard-tools (= ${source:Version}),
 Description: fast, modern, secure kernel VPN tunnel (DKMS version)

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_VERSION_UPSTREAM
 
-WIREGUARD_ARGS = WITH_BASHCOMPLETION=yes WITH_WGQUICK=yes WITH_SYSTEMDUNITS=yes
+WIREGUARD_ARGS = WITH_BASHCOMPLETION=yes WITH_WGQUICK=yes WITH_SYSTEMDUNITS=yes V=1
 
 %:
 	dh $@ --with dkms

## wireguard 1.0.20200121

=== src/fuzz/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Copyright (C) 2018-2020 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.

FUZZERS := config uapi stringlist cmd set setconf

all: $(FUZZERS)

CFLAGS ?= -O3 -march=native -g
CFLAGS += -fsanitize=fuzzer -fsanitize=address -std=gnu11 -idirafter ../uapi -D_GNU_SOURCE
CC := clang

config: config.c ../config.c ../encoding.c
	$(CC) $(CFLAGS) -o $@ $<

uapi: uapi.c ../ipc.c ../curve25519.c ../encoding.c
	$(CC) $(CFLAGS) -o $@ $<

stringlist: stringlist.c ../ipc.c ../curve25519.c ../encoding.c
	$(CC) $(CFLAGS) -o $@ $<

cmd: cmd.c $(wildcard ../*.c)
	$(CC) $(CFLAGS) -D'RUNSTATEDIR="/var/empty"' -D'main(a,b)=wg_main(a,b)' -o $@ $^ -lmnl

set: set.c ../set.c ../ipc.c ../encoding.c ../mnlg.c ../curve25519.c ../config.c
	$(CC) $(CFLAGS) -o $@ $< -lmnl

setconf: setconf.c ../setconf.c ../ipc.c ../encoding.c ../mnlg.c ../curve25519.c ../config.c
	$(CC) $(CFLAGS) -o $@ $< -lmnl

clean:
	$(RM) $(FUZZERS)

.PHONY: all clean

=== debian/changelog ===
wireguard (1.0.20200121-2~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Fri, 07 Feb 2020 12:38:20 -0800

wireguard (1.0.20200121-2) unstable; urgency=medium

  * Transfer module reload postinst script to wireguard-dkms package
  * standards-version: bump to 4.5.0 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 22 Jan 2020 13:16:57 -0500

wireguard (1.0.20200121-1) unstable; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 21 Jan 2020 10:12:22 -0500

wireguard (1.0.20200102-1) unstable; urgency=medium

  * new upstream release
  * drop wireguard-dkms binary package, now supplied by the
    wireguard-linux-compat source package
  * refresh patches
  * drop lintian override of version-substvar-for-external-package
  * ship examples from new upstream path
  * update debian/copyright
  * avoid using git during build to override src/version.h

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 15 Jan 2020 11:25:16 -0500

wireguard (0.0.20191219-1) unstable; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 19 Dec 2019 11:33:41 -0500

wireguard (0.0.20191212-1) unstable; urgency=medium

  * new upstream release
  * encourage nftables instead of iptables

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 12 Dec 2019 10:53:37 -0500

wireguard (0.0.20191206-1) unstable; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 06 Dec 2019 17:32:38 -0500

wireguard (0.0.20191127-2) unstable; urgency=medium

  * wireguard-tools now Recommends: iptables because of wg-quick

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 04 Dec 2019 10:46:36 -0500

wireguard (0.0.20191127-1) unstable; urgency=medium

  * new upstream release

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 02 Dec 2019 09:44:34 -0500

wireguard (0.0.20191012-1) unstable; urgency=medium

  * new upstream release
  * d/clean: clean up generated assembler
  * more notes about autopkgtest
  * standards-version: bump to 4.4.1 (no changes needed)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 15 Oct 2019 17:41:38 +0200

=== debian/control ===
Source: wireguard
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 debhelper-compat (= 12),
 dkms,
 libmnl-dev,
 pkg-config,
 systemd,
Standards-Version: 4.5.0
Homepage: https://www.wireguard.com
Vcs-Git: https://salsa.debian.org/debian/wireguard.git
Vcs-Browser: https://salsa.debian.org/debian/wireguard
Rules-Requires-Root: no

Package: wireguard
Architecture: all
Depends:
 wireguard-dkms (>= 0.0.20200121-2) | wireguard-modules (>= 0.0.20191219),
 wireguard-tools (>= ${source:Version}),
 ${misc:Depends},
Description: fast, modern, secure kernel VPN tunnel (metapackage)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This metapackage explicitly depends on both the kernel module and the
 userspace tooling.  If this metapackage is installed, and wireguard
 is already in use on the system, the kernel module will be reloaded
 when the module is upgraded.

Package: wireguard-tools
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 nftables | iptables,
 wireguard-dkms (>= 0.0.20191219) | wireguard-modules (>= 0.0.20171001),
Description: fast, modern, secure kernel VPN tunnel (userland utilities)
 WireGuard is a novel VPN that runs inside the Linux Kernel and uses
 state-of-the-art cryptography (the "Noise" protocol). It aims to be
 faster, simpler, leaner, and more useful than IPSec, while avoiding
 the massive headache. It intends to be considerably more performant
 than OpenVPN. WireGuard is designed as a general purpose VPN for
 running on embedded interfaces and super computers alike, fit for
 many different circumstances. It runs over UDP.
 .
 This package contains command-line tools to interact with the
 WireGuard kernel module.  Currently, it provides only a single tool:
 .
 wg: set and retrieve configuration of WireGuard interfaces

=== debian/watch ===
version=4
opts=mode=git,pgpmode=gittag \
 https://git.zx2c4.com/WireGuard \
 refs/tags/([\d\.]+)

## wireguard 1.0.20200206

=== debian/changelog ===
wireguard (1.0.20200206-2~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 04 Mar 2020 18:34:05 -0800

wireguard (1.0.20200206-2) unstable; urgency=medium

  * add NEWS file documenting that the metapackage will no longer cause a
    reload.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 24 Feb 2020 10:08:35 -0500

wireguard (1.0.20200206-1) unstable; urgency=medium

  * new upstream release.
  * d/copyright: note import of bits from libmnl
  * refresh patches
  * drop libmnl-dev from build-deps

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 06 Feb 2020 14:06:44 -0500

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_VERSION_UPSTREAM

WIREGUARD_ARGS = WITH_BASHCOMPLETION=yes WITH_WGQUICK=yes WITH_SYSTEMDUNITS=yes V=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=src -- $(WIREGUARD_ARGS)

override_dh_auto_install-arch:
	$(MAKE) -C src DESTDIR=../debian/wireguard-tools $(WIREGUARD_ARGS) install

override_dh_fixperms:
	dh_fixperms -Xetc/wireguard

override_dh_installexamples:
	dh_installexamples -Xexternal-tests

override_dh_strip:
	dh_strip --no-automatic-dbgsym
